<?php

namespace MyApp\Model;

use MyApp\DB\DB;
use MyApp\Model\Resource\City;

class User
{
    protected $firstName;
    protected $lastName;
    protected $ID;
    protected $email;
    protected $street;
    protected $street2;
    protected $housenumber;
    protected $bus;
    protected $city;
    protected $country;
    protected $birthDate;
    protected $mobile;
    protected $phone;
    protected $newsletter;

    protected $db;

    public function __construct(DB $db)
    {
        $this->db = $db;
    }
    public function setFirstName($value)
    {
        // Checks implementeren

        $this->firstName = $value;
    }
    public function setLastName($value)
    {
        $this->lastName = $value;
    }
    public function setEmail($value)
    {
        $this->email = $value;
    }
    public function setStreet($value)
    {
        $this->street = $value;
    }
    public function setStreet2($value)
    {
        $this->street2 = $value;
    }
    public function setMobile($value)
    {
        $this->mobile = $value;
    }

    public function setCity($name, $zipcode)
    {
        $city = new City($name, $zipcode);
        $this->city = $city;
    }

    public function getName()
    {
        return $this->firstName . " " . $this->lastName;
    }

    public function getMobile()
    {
        // formattering van de output
        return $this->mobile;
    }


    // List of all order of a client
    // zeer complexe functie, veel parameters die zeer correct ingevuld moeten worden
    protected function listOrders($dateStart, $dateEnd, $status)
    {
        return;
    }

    public function orderHistory()
    {
        $datestart = date('');
        $dateend = date('');
        return $this->listOrders($datestart, $dateend, 'delivered');
    }

    public function showAddress()
    {
    }

    public function loadUser()
    {
    }


    public function validateUser($username, $password)
    {

        $sql = "SELECT * FROM users LEFT JOIN city on city.id = users.cityID where username = :user AND password = :pass";
        $stmt  = $this->db->prepare($sql);
        $stmt->bindValue(":user", $username, SQLITE3_TEXT);
        $stmt->bindValue(":pass", $password, SQLITE3_TEXT);
        $res = $stmt->execute();

        if ($data = $res->fetchArray(SQLITE3_ASSOC)) {

            $this->setEmail($data["email"]);
            $this->setFirstName($data["firstname"]);
            $this->setLastName($data["lastname"]);
            $this->setCity($data["name"], $data["zipcode"]);

            return True;
        }

        return False;
    }
}
